Subject: Re: RFC: Support send-to-self over external interfaces (and veths).

From: Patrick McHardy <[email-masked]>
Date: Mon, 11 Jun 2007 14:34:45 +0200

Ben Greear wrote:
> This should also be useful with the pending 'veth' driver, as it
> emulates two ethernet ports connected with a cross-over cable.
> 
> To make this work, you have to enable the sysctl (look Dave,
> no IOCTLS, there might be hope for me yet!! :)), and in your
> application you will need to use SO_BINDTODEVICE (and probably bind to
> the local IP as well).  Some applications such as traceroute already
> support this binding..others such as ping do not.
> 
> You most likely will also have to set up routing tables using
> source IPs as a rule to direct these connections to a particular
> routing table.
> 
> Comments welcome.

I would really prefer to simply make the prio 0 "lookup local"
rule deletable so you can rules with higher priority. That
allows to do send to self without any further code changes
and avoids the need to bind applications to a device.